#include <string.h>
#include <stdio.h>
#include <math.h>
#include <XRS/string_format.h>

//***************** string format function ***********************

void string(char *p,char* s,int n)
{
    register i,j,k;
    char *ss=new char [n+1];

    i=strlen(s);
    if( i > n ) i=n;
    k=(int)((n-i)/2);
    for( j=0; j<k; j++ ) ss[j]=' ';
    ss[k]='\0';
    strncat(ss,s,i);
    for(j=k+i; j<n; j++) ss[j]=' ';
    ss[n]='\0';
    
    strcpy(p,ss);
    delete [] ss; ss=NULL;
}


void parameter_string(char *s,char *ds,double p,double dp,char *format)
{
   register int k,n,i,digit;
   char *dot;

   digit=(int)floor(log10(dp)+0.5);
   if(digit>=0) digit++;

   sprintf(s,format,p);
   i=strlen(s);
   for(k=0; k<i; k++) ds[k]=' ';
   ds[i]='\0';

   if( (dot=strrchr(s,'.'))==NULL ) dot=strrchr(s,'\0');
   n=dot-digit-s;
   if( n >=0 && n < i) ds[n]=*(dot-digit);
}


void parameter_string(char *s,char *ds,int p,int dp,char *format)
{
   register int k,n,i,digit;
   char *dot;

   digit=(int)floor(log10(dp)+0.5)+2;
   sprintf(s,format,p);
   i=strlen(s);
   for(k=0; k<i; k++) ds[k]=' ';
   ds[i]='\0';

   dot=strrchr(s,'\0');
   n=dot-digit-s;
   if( n >=0 && n < i) ds[n]=*(dot-digit);
}


void copy_string(char *&s1,char *s2){
   if(s1!=NULL){ delete [] s1; s1=NULL;}
   s1=new char [strlen(s2)+1];
   strcpy(s1,s2);
}


int field_width(char *s){
   int fw=0;
   if(s==NULL) return 0;
   char *s1=new char [strlen(s)+1]; strcpy(s1,s);
   sscanf(s1,"%*[%-+ #]%d",&fw);
   delete [] s1;
   return fw;
}

