#define XRS_SOURCE
#include <XRS/f_dialog.h>
#include <XRS/color.h>
#include <XRS/string_format.h>
#include <XRS/define.h>
#undef XRS_SOURCE


//************** class f_dialog *******************

#define extractZ(n,c,x) if(extractOpt(win.rDB,n,c,opt)) x=atoi(opt);if(x<1) x=1
#define extractI(n,c,x) if(extractOpt(win.rDB,n,c,opt)) x=atoi(opt);if(x<0) x=0
#define extractS(n,c,x) if(extractOpt(win.rDB,n,c,opt)) copy_string(x,opt) 

void f_dialog::initialize(){

//------------- fBtHgl̎擾  ---------------

   int F_Dialog_Width,F_Dialog_Height;
   char *F_Dialog_Font=NULL;

   F_Dialog_String =F_DIALOG_STRING;
   F_Dialog_Xoffset=F_DIALOG_XOFFSET;
   F_Dialog_Yoffset=F_DIALOG_YOFFSET;
   F_Dialog_Width  =F_DIALOG_WIDTH;
   F_Dialog_Height =F_DIALOG_HEIGHT;
   copy_string(F_Dialog_Font,F_DIALOG_FONT);

   char opt[126];

   extractZ("xrs.dialog.function.string",
            "Xrs.Dialog.Function.String",F_Dialog_String); 

   extractI("xrs.dialog.function.xoffset",
            "Xrs.Dialog.Function.Xoffset",F_Dialog_Xoffset); 

   extractI("xrs.dialog.function.yoffset",
            "Xrs.Dialog.Function.Yoffset",F_Dialog_Yoffset); 

   extractZ("xrs.dialog.function.width",
            "Xrs.Dialog.Function.Width",F_Dialog_Width); 

   extractZ("xrs.dialog.function.height",
            "Xrs.Dialog.Function.Height",F_Dialog_Height); 

   extractS("xrs.dialog.function.font",
            "Xrs.Dialog.Function.Font",F_Dialog_Font);

//----------------------------------------------

   gc = graphic_context(win,win.black,0,LineSolid,F_Dialog_Font);
 
   w=F_Dialog_Width; 
   h=F_Dialog_Height; 
   delete [] F_Dialog_Font; F_Dialog_Font=NULL;
}


void f_dialog::checkevent(){
   register int x=win.ev.xbutton.x,y=win.ev.xbutton.y; chev=0;
   if(x>i0 && x<i0+w && y>j0 && y<j0+h){
      if(f!=NULL) f(win.ev.xbutton.button); chev=1;
   }
}


void f_dialog::redraw(){
   if(win.disp()==NULL) return;
   char wanya[F_Dialog_String+1];
   string(wanya,name,F_Dialog_String);
   XDrawRectangle(win.disp(),win,gc,i0+1,j0+1,w-2,h-2);
   XDrawImageString(win.disp(),win,gc,
    i0+F_Dialog_Xoffset,j0+h-F_Dialog_Yoffset,wanya,F_Dialog_String);
   XFlush(win.disp());
}

